Package | Class | Tree | Serialized | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.ibm.crypto.fips.provider
Class DHKeyAgreement

    java.lang.Object
      |
      +--javax.crypto.KeyAgreementSpi
            |
            +--com.ibm.crypto.fips.provider.DHKeyAgreement

All Implemented Interfaces:
  AlgorithmStatus

public final class DHKeyAgreement
extends javax.crypto.KeyAgreementSpi
implements AlgorithmStatus

This class implements the Diffie-Hellman key agreement protocol between any number of parties.

Version:
  1.9, 05/19/03
Author:
  Jan Luehe, John Peck

Constructor Summary
`DHKeyAgreement()` Verify the JCE framework in the constructor.

Method Summary
`protected java.security.Key` | `engineDoPhase(java.security.Key key, boolean lastPhase)` Executes the next phase of this key agreement with the given key that was received from one of the other parties involved in this key agreement.
`protected byte[]` | `engineGenerateSecret()` Generates the shared secret and returns it in a new buffer.
`protected int` | `engineGenerateSecret(byte[] sharedSecret, int offset)` Generates the shared secret, and places it into the buffer `sharedSecret`, beginning at `offset`.
`protected javax.crypto.SecretKey` | `engineGenerateSecret(java.lang.String algorithm)` Creates the shared secret and returns it as a secret key object of the requested algorithm type.
`protected void` | `engineInit(java.security.Key key, java.security.spec.AlgorithmParameterSpec params, java.security.SecureRandom random)` Initializes this key agreement with the given key, set of algorithm parameters, and source of randomness.
`protected void` | `engineInit(java.security.Key key, java.security.SecureRandom random)` Initializes this key agreement with the given key and source of randomness.
`protected java.security.Key` | `internalDoPhase(java.security.Key key, boolean lastPhase)` Executes the next phase of this key agreement with the given key that was received from one of the other parties involved in this key agreement.
`protected byte[]` | `internalGenerateSecret()` Generates the shared secret and returns it in a new buffer.
`protected int` | `internalGenerateSecret(byte[] sharedSecret, int offset)` Generates the shared secret, and places it into the buffer `sharedSecret`, beginning at `offset`.
`protected javax.crypto.SecretKey` | `internalGenerateSecret(java.lang.String algorithm)` Creates the shared secret and returns it as a secret key object of the requested algorithm type.
`protected void` | `internalInit(java.security.Key key, java.security.spec.AlgorithmParameterSpec params, java.security.SecureRandom random)` Initializes this key agreement with the given key, set of algorithm parameters, and source of randomness.
`boolean` | `isFipsApproved()` This function allows an application to verify the the algorithm is FIPS approved.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### DHKeyAgreement

    public DHKeyAgreement()

  Verify the JCE framework in the constructor.
  Throws:
    `java.lang.SecurityException` - if fails to verify the JCE framework.

Method Detail

### isFipsApproved

    public boolean isFipsApproved()

  This function allows an application to verify the the algorithm is FIPS approved.
  Specified by:
    `isFipsApproved` in interface `AlgorithmStatus`
  See Also:
    `AlgorithmStatus.isFipsApproved()`

### engineInit

    protected void engineInit(java.security.Key key,
                              java.security.SecureRandom random)
                       throws java.security.InvalidKeyException

  Initializes this key agreement with the given key and source of randomness. The given key is required to contain all the algorithm parameters required for this key agreement.

  If the key agreement algorithm requires random bytes, it gets them from the given source of randomness, `random`. However, if the underlying algorithm implementation does not require any random bytes, `random` is ignored.

  Overrides:
    `engineInit` in class `javax.crypto.KeyAgreementSpi`
  Parameters:
    `key` - the party's private information. For example, in the case of the Diffie-Hellman key agreement, this would be the party's own Diffie-Hellman private key.
    `random` - the source of randomness
  Throws:
    `java.security.InvalidKeyException` - if the given key is inappropriate for this key agreement, e.g., is of the wrong type or has an incompatible algorithm type.

### engineInit

    protected void engineInit(java.security.Key key,
                              java.security.spec.AlgorithmParameterSpec params,
                              java.security.SecureRandom random)
                       throws java.security.InvalidKeyException,
                              java.security.InvalidAlgorithmParameterException

  Initializes this key agreement with the given key, set of algorithm parameters, and source of randomness.
  Overrides:
    `engineInit` in class `javax.crypto.KeyAgreementSpi`
  Parameters:
    `key` - the party's private information. For example, in the case of the Diffie-Hellman key agreement, this would be the party's own Diffie-Hellman private key.
    `params` - the key agreement parameters
    `random` - the source of randomness
  Throws:
    `java.security.InvalidKeyException` - if the given key is inappropriate for this key agreement, e.g., is of the wrong type or has an incompatible algorithm type.
    `java.security.InvalidAlgorithmParameterException` - if the given parameters are inappropriate for this key agreement.

### internalInit

    protected void internalInit(java.security.Key key,
                                java.security.spec.AlgorithmParameterSpec params,
                                java.security.SecureRandom random)
                         throws java.security.InvalidKeyException,
                                java.security.InvalidAlgorithmParameterException

  Initializes this key agreement with the given key, set of algorithm parameters, and source of randomness.
  Parameters:
    `key` - the party's private information. For example, in the case of the Diffie-Hellman key agreement, this would be the party's own Diffie-Hellman private key.
    `params` - the key agreement parameters
    `random` - the source of randomness
  Throws:
    `java.security.InvalidKeyException` - if the given key is inappropriate for this key agreement, e.g., is of the wrong type or has an incompatible algorithm type.
    `java.security.InvalidAlgorithmParameterException` - if the given parameters are inappropriate for this key agreement.

### engineDoPhase

    protected java.security.Key engineDoPhase(java.security.Key key,
                                              boolean lastPhase)
                                       throws java.security.InvalidKeyException,
                                              java.lang.IllegalStateException

  Executes the next phase of this key agreement with the given key that was received from one of the other parties involved in this key agreement.
  Overrides:
    `engineDoPhase` in class `javax.crypto.KeyAgreementSpi`
  Parameters:
    `key` - the key for this phase. For example, in the case of Diffie-Hellman between 2 parties, this would be the other party's Diffie-Hellman public key.
    `lastPhase` - flag which indicates whether or not this is the last phase of this key agreement.
  Returns:
    the (intermediate) key resulting from this phase, or null if this phase does not yield a key
  Throws:
    `java.security.InvalidKeyException` - if the given key is inappropriate for this phase.
    `java.lang.IllegalStateException` - if this key agreement has not been initialized.

### internalDoPhase

    protected java.security.Key internalDoPhase(java.security.Key key,
                                                boolean lastPhase)
                                         throws java.security.InvalidKeyException,
                                                java.lang.IllegalStateException

  Executes the next phase of this key agreement with the given key that was received from one of the other parties involved in this key agreement.
  Parameters:
    `key` - the key for this phase. For example, in the case of Diffie-Hellman between 2 parties, this would be the other party's Diffie-Hellman public key.
    `lastPhase` - flag which indicates whether or not this is the last phase of this key agreement.
  Returns:
    the (intermediate) key resulting from this phase, or null if this phase does not yield a key
  Throws:
    `java.security.InvalidKeyException` - if the given key is inappropriate for this phase.
    `java.lang.IllegalStateException` - if this key agreement has not been initialized.

### engineGenerateSecret

    protected byte[] engineGenerateSecret()
                                   throws java.lang.IllegalStateException

  Generates the shared secret and returns it in a new buffer.

  This method resets this `KeyAgreementSpi` object, so that it can be reused for further key agreements. Unless this key agreement is reinitialized with one of the `engineInit` methods, the same private information and algorithm parameters will be used for subsequent key agreements.

  Overrides:
    `engineGenerateSecret` in class `javax.crypto.KeyAgreementSpi`
  Returns:
    the new buffer with the shared secret
  Throws:
    `java.lang.IllegalStateException` - if this key agreement has not been completed yet

### internalGenerateSecret

    protected byte[] internalGenerateSecret()
                                     throws java.lang.IllegalStateException

  Generates the shared secret and returns it in a new buffer.

  This method resets this `KeyAgreementSpi` object, so that it can be reused for further key agreements. Unless this key agreement is reinitialized with one of the `engineInit` methods, the same private information and algorithm parameters will be used for subsequent key agreements.

  Returns:
    the new buffer with the shared secret
  Throws:
    `java.lang.IllegalStateException` - if this key agreement has not been completed yet

### engineGenerateSecret

    protected int engineGenerateSecret(byte[] sharedSecret,
                                       int offset)
                                throws java.lang.IllegalStateException,
                                       javax.crypto.ShortBufferException

  Generates the shared secret, and places it into the buffer `sharedSecret`, beginning at `offset`.

  If the `sharedSecret` buffer is too small to hold the result, a `ShortBufferException` is thrown. In this case, this call should be repeated with a larger output buffer.

  This method resets this `KeyAgreementSpi` object, so that it can be reused for further key agreements. Unless this key agreement is reinitialized with one of the `engineInit` methods, the same private information and algorithm parameters will be used for subsequent key agreements.

  Overrides:
    `engineGenerateSecret` in class `javax.crypto.KeyAgreementSpi`
  Parameters:
    `sharedSecret` - the buffer for the shared secret
    `offset` - the offset in `sharedSecret` where the shared secret will be stored
  Returns:
    the number of bytes placed into `sharedSecret`
  Throws:
    `java.lang.IllegalStateException` - if this key agreement has not been completed yet
    `javax.crypto.ShortBufferException` - if the given output buffer is too small to hold the secret

### internalGenerateSecret

    protected int internalGenerateSecret(byte[] sharedSecret,
                                         int offset)
                                  throws java.lang.IllegalStateException,
                                         javax.crypto.ShortBufferException

  Generates the shared secret, and places it into the buffer `sharedSecret`, beginning at `offset`.

  If the `sharedSecret` buffer is too small to hold the result, a `ShortBufferException` is thrown. In this case, this call should be repeated with a larger output buffer.

  This method resets this `KeyAgreementSpi` object, so that it can be reused for further key agreements. Unless this key agreement is reinitialized with one of the `engineInit` methods, the same private information and algorithm parameters will be used for subsequent key agreements.

  Parameters:
    `sharedSecret` - the buffer for the shared secret
    `offset` - the offset in `sharedSecret` where the shared secret will be stored
  Returns:
    the number of bytes placed into `sharedSecret`
  Throws:
    `java.lang.IllegalStateException` - if this key agreement has not been completed yet
    `javax.crypto.ShortBufferException` - if the given output buffer is too small to hold the secret

### engineGenerateSecret

    protected javax.crypto.SecretKey engineGenerateSecret(java.lang.String algorithm)
                                                   throws java.lang.IllegalStateException,
                                                          java.security.NoSuchAlgorithmException,
                                                          java.security.InvalidKeyException

  Creates the shared secret and returns it as a secret key object of the requested algorithm type.

  This method resets this `KeyAgreementSpi` object, so that it can be reused for further key agreements. Unless this key agreement is reinitialized with one of the `engineInit` methods, the same private information and algorithm parameters will be used for subsequent key agreements.

  Overrides:
    `engineGenerateSecret` in class `javax.crypto.KeyAgreementSpi`
  Parameters:
    `algorithm` - the requested secret key algorithm
  Returns:
    the shared secret key
  Throws:
    `java.lang.IllegalStateException` - if this key agreement has not been completed yet
    `java.security.NoSuchAlgorithmException` - if the requested secret key algorithm is not available
    `java.security.InvalidKeyException` - if the shared secret key material cannot be used to generate a secret key of the requested algorithm type (e.g., the key material is too short)

### internalGenerateSecret

    protected javax.crypto.SecretKey internalGenerateSecret(java.lang.String algorithm)
                                                     throws java.lang.IllegalStateException,
                                                            java.security.NoSuchAlgorithmException,
                                                            java.security.InvalidKeyException

  Creates the shared secret and returns it as a secret key object of the requested algorithm type.

  This method resets this `KeyAgreementSpi` object, so that it can be reused for further key agreements. Unless this key agreement is reinitialized with one of the `engineInit` methods, the same private information and algorithm parameters will be used for subsequent key agreements.

  Parameters:
    `algorithm` - the requested secret key algorithm
  Returns:
    the shared secret key
  Throws:
    `java.lang.IllegalStateException` - if this key agreement has not been completed yet
    `java.security.NoSuchAlgorithmException` - if the requested secret key algorithm is not available
    `java.security.InvalidKeyException` - if the shared secret key material cannot be used to generate a secret key of the requested algorithm type (e.g., the key material is too short)

Package | Class | Tree | Serialized | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD